# Class OjNavigationList

The component WebElement for oj-navigation-list. Do not instantiate this class directly, instead, use ojNavigationList.

#### Hierarchy

- OjNavigationListBase
  - OjNavigationList

#####
Index

### Constructors

constructor

### Methods

changeCurrentItem
changeExpanded
changeExpandedByIndex
changeSelection
changeSelectionByIndex
clear
click
doSelection
findElement
findElements
findItem
getAs
getAttribute
getCssValue
getCurrentItem
getDisplay
getDrillMode
getEdge
getExpanded
getHierarchyMenuThreshold
getItem
getItemByIndex
getLocation
getOverflow
getProperty
getRect
getRootLabel
getSelection
getSize
getText
getTranslations
hasSize
hasVisibility
isDisplayed
isEnabled
isSelected
sendKeys
setProperty
submit
takeScreenshot
whenBusyContextReady
whenReady

## Constructors

### constructor

- new OjNavigationList(el, locators): OjNavigationList

- Constructor. Pass an instance of WebDriver's WebElement that represents the DOM node on which we"ll perform operations.

  #### Parameters

  - ##### el: WebElement

    The basic WebElement with which this WebElement will work.

  - ##### locators: ElementLocators

  #### Returns OjNavigationList

  Inherited from OjNavigationListBase.constructor

## Methods

### changeCurrentItem

- changeCurrentItem(currentItem): Promise<void>

- Sets the value of `currentItem` property. Specifies the key of the item that should have keyboard focus. See the Help documentation for more information.

  #### Parameters

  - ##### currentItem: any

    The value to set for `currentItem`

  #### Returns Promise<void>

  Inherited from OjNavigationListBase.changeCurrentItem

### changeExpanded

- changeExpanded(expanded): Promise<void>

- Sets the value of "expanded" property. Specifies the key set containing the keys of the items that should be expanded. Use the ExpandedKeySet class to specify items to expand. Use the ExpandAllKeySet class to expand all items.

  #### Parameters

  - ##### expanded: any[]

    The value to set for "expanded"

  #### Returns Promise<void>

### changeExpandedByIndex

- changeExpandedByIndex(indexes): Promise<void>

- #### Parameters

  - ##### indexes: number[][]

  #### Returns Promise<void>

### changeSelection

- changeSelection(selection): Promise<void>

- Sets the value of `selection` property. Specifies the key of the selected item. See the Help documentation for more information.

  #### Parameters

  - ##### selection: any

    The value to set for `selection`

  #### Returns Promise<void>

  #### Deprecated

  Since 16.1.0. Instead use doSelection to change selection.

  Overrides OjNavigationListBase.changeSelection

### changeSelectionByIndex

- changeSelectionByIndex(index): Promise<void>

- Selets item specified by index path. Note: This expands all intermediate items too.

  #### Parameters

  - ##### index: number | number[]

    array of index path to the element to be selected

  #### Returns Promise<void>

### clear

- clear(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from OjNavigationListBase.clear

### click

- click(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from OjNavigationListBase.click

### doSelection

- doSelection<K>(key): Promise<void>

- Selects item specified by key. Triggers ojSelectionAction if the key passed is same as the current selection value.

  #### Type Parameters

  - #### K

  #### Parameters

  - ##### key: K

    key of the item to be selected

  #### Returns Promise<void>

### findElement

- findElement(locator): WebElementPromise

- #### Parameters

  - ##### locator: Locator

  #### Returns WebElementPromise

  #### Inherit Doc

  Inherited from OjNavigationListBase.findElement

### findElements

- findElements(locator): Promise<WebElement[]>

- #### Parameters

  - ##### locator: Locator

  #### Returns Promise<WebElement[]>

  #### Inherit Doc

  Inherited from OjNavigationListBase.findElements

### findItem

- findItem<T>(itemLocator): Promise<SlotProxy>

- Retrieve a SlotProxy which represents a single navlist item.

  #### Type Parameters

  - #### T

  #### Parameters

  - ##### itemLocator: {
    key: T;
    }

    - ##### key: T

  #### Returns Promise<SlotProxy>

### getAs

- getAs(): Promise<string>

- Gets the value of `as` property. Specifies the alias for the current item when referenced inside the item template.

  #### Returns Promise<string>

  The value of `as` property.

  #### Deprecated

  Since 6.2.0. Set the alias directly on the template element using the data-oj-as attribute instead.

  Inherited from OjNavigationListBase.getAs

### getAttribute

- getAttribute(attributeName): Promise<string>

- #### Parameters

  - ##### attributeName: string

  #### Returns Promise<string>

  #### Inherit Doc

  Inherited from OjNavigationListBase.getAttribute

### getCssValue

- getCssValue(cssStyleProperty): Promise<string>

- #### Parameters

  - ##### cssStyleProperty: string

  #### Returns Promise<string>

  #### Inherit Doc

  Inherited from OjNavigationListBase.getCssValue

### getCurrentItem

- getCurrentItem(): Promise<any>

- Gets the value of `currentItem` property. Specifies the key of the item that should have keyboard focus. See the Help documentation for more information.

  #### Returns Promise<any>

  The value of `currentItem` property.

  Inherited from OjNavigationListBase.getCurrentItem

### getDisplay

- getDisplay(): Promise<string>

- Gets the value of `display` property. Specifies what needs to be displayed. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `display` property.

  Inherited from OjNavigationListBase.getDisplay

### getDrillMode

- getDrillMode(): Promise<string>

- Gets the value of `drillMode` property. Specifies whether expand/collapse or sliding operations are allowed.

  #### Returns Promise<string>

  The value of `drillMode` property.

  Inherited from OjNavigationListBase.getDrillMode

### getEdge

- getEdge(): Promise<string>

- Gets the value of `edge` property. Specifies the edge position of the Navigation List.

  #### Returns Promise<string>

  The value of `edge` property.

  #### Deprecated

  Since 17.0.0. Support for horizontal layout in oj-navigation-list is deprecated - use oj-tab-bar instead.

  Inherited from OjNavigationListBase.getEdge

### getExpanded

- getExpanded(): Promise<any[]>

- Gets the value of "expanded" property. Specifies the key set containing the keys of the items that should be expanded.

  Use the ExpandedKeySet class to specify items to expand. Use the ExpandAllKeySet class to expand all items.

  #### Returns Promise<any[]>

  The value of "expanded" property.

### getHierarchyMenuThreshold

- getHierarchyMenuThreshold(): Promise<number>

- Gets the value of `hierarchyMenuThreshold` property. Specifies the level at which the user can see hierarchical menu button. See the Help documentation for more information.

  #### Returns Promise<number>

  The value of `hierarchyMenuThreshold` property.

  #### Deprecated

  Since 13.0.0. This is not supported in the Redwood theme.

  Inherited from OjNavigationListBase.getHierarchyMenuThreshold

### getItem

- getItem(): Promise<Item>

- Gets the value of `item` property. Customize the functionality of each item in Navigation List.

  #### Returns Promise<Item>

  The value of `item` property.

  Inherited from OjNavigationListBase.getItem

### getItemByIndex

- getItemByIndex(indexPath): Promise<undefined | WebElement>

- Returns item node specified by index path.

  #### Parameters

  - ##### indexPath: number[]

  #### Returns Promise<undefined | WebElement>

### getLocation

- getLocation(): Promise<ILocation>

- #### Returns Promise<ILocation>

  #### Inherit Doc

  Inherited from OjNavigationListBase.getLocation

### getOverflow

- getOverflow(): Promise<string>

- Gets the value of `overflow` property. Specifies overflow behaviour for the Navigation List.

  #### Returns Promise<string>

  The value of `overflow` property.

  #### Deprecated

  Since 17.0.0. Support for horizontal layout in oj-navigation-list is deprecated - use oj-tab-bar instead.

  Inherited from OjNavigationListBase.getOverflow

### getProperty

- getProperty<T>(propertyName): Promise<T>

- Get a named property value from this component. This function will wait for the application's busy context to complete before attempting to get the property value.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The name of the property

  #### Returns Promise<T>

  A Promise that yields a value for the named property.

  Inherited from OjNavigationListBase.getProperty

### getRect

- getRect(): Promise<IRectangle>

- #### Returns Promise<IRectangle>

  #### Inherit Doc

  Inherited from OjNavigationListBase.getRect

### getRootLabel

- getRootLabel(): Promise<string>

- Gets the value of `rootLabel` property. Specifies the label for top level list items.

  #### Returns Promise<string>

  The value of `rootLabel` property.

  Inherited from OjNavigationListBase.getRootLabel

### getSelection

- getSelection(): Promise<any>

- Gets the value of `selection` property. Specifies the key of the selected item. See the Help documentation for more information.

  #### Returns Promise<any>

  The value of `selection` property.

  Inherited from OjNavigationListBase.getSelection

### getSize

- getSize(): Promise<ISize>

- #### Returns Promise<ISize>

  #### Inherit Doc

  Inherited from OjNavigationListBase.getSize

### getText

- getText(): Promise<string>

- #### Returns Promise<string>

  #### Inherit Doc

  Inherited from OjNavigationListBase.getText

### getTranslations

- getTranslations(): Promise<null | Translations>

- Gets the value of `translations` property. A collection of translated resources from the translation bundle, or null if this component has no resources.

  #### Returns Promise<null | Translations>

  The value of `translations` property.

  Inherited from OjNavigationListBase.getTranslations

### `Protected` hasSize

- hasSize(): Condition<Promise<boolean>>

- Create a wait condition that is satisfied when the element's DOM has a non-zero size.

  #### Returns Condition<Promise<boolean>>

  The Condition to be used with driver.wait() that's satisfied when the element's DOM has a non-zero size.

  #### Deprecated

  Since 11.0.0. Call the appropriate WebElement method to test the size of the element.

  Inherited from OjNavigationListBase.hasSize

### `Protected` hasVisibility

- hasVisibility(): Condition<Promise<boolean>>

- Create a wait condition that is satisfid when the element is visible. The condition is satisfied when the element is displayed, as reported by #isDisplayed, and is scrolled into view. This is method is deprecated. Use WebElement.isDisplayed instead to test the display of the element, and scroll it into view if necessary.

  #### Returns Condition<Promise<boolean>>

  #### Deprecated

  Inherited from OjNavigationListBase.hasVisibility

### isDisplayed

- isDisplayed(): Promise<boolean>

- #### Returns Promise<boolean>

  #### Inherit Doc

  Inherited from OjNavigationListBase.isDisplayed

### isEnabled

- isEnabled(): Promise<boolean>

- #### Returns Promise<boolean>

  #### Inherit Doc

  Inherited from OjNavigationListBase.isEnabled

### isSelected

- isSelected(): Promise<boolean>

- #### Returns Promise<boolean>

  #### Inherit Doc

  Inherited from OjNavigationListBase.isSelected

### sendKeys

- sendKeys(...varArgs): Promise<void>

- #### Parameters

  - ##### `Rest` ...varArgs: (string | number | Promise<string | number>)[]

  #### Returns Promise<void>

  #### Inherit Doc

  Inherited from OjNavigationListBase.sendKeys

### `Protected` setProperty

- setProperty<T>(propertyName, value): Promise<void>

- Set a property value on the remote element. This function first waits for the BusyContext to clear before setting the property, then after setting, waits again to ensure that no additional busy states were created due to the property setting.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The property name to set

  - ##### value: T

    The value to set for the property

  #### Returns Promise<void>

  A Promise which resolves when the remote property has been set to the value. Any value returned from the call to set the remote property is returned in the Promise.

  Inherited from OjNavigationListBase.setProperty

### submit

- submit(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from OjNavigationListBase.submit

### takeScreenshot

- takeScreenshot(optScroll?): Promise<string>

- #### Parameters

  - ##### `Optional` optScroll: boolean

  #### Returns Promise<string>

  #### Inherit Doc

  Inherited from OjNavigationListBase.takeScreenshot

### whenBusyContextReady

- whenBusyContextReady(): Promise<void>

- Returns a Promise that is resolved when the application's busy state reports ready. This method checks only that the application's busy context is ready, and not that the DOM element is actually displayed or has a physical size, such as is the case with #whenReady. Operations which are read-only in nature should call this method prior to execution.

  #### Returns Promise<void>

  A Promise which is resolved when the page's busy state is ready.

  Inherited from OjNavigationListBase.whenBusyContextReady

### whenReady

- whenReady(): Promise<void>

- Returns a Promise that is resolved when the element is ready for interaction--it is visible, has a size, and the app's busy context is ready. Operations on the DOM which rely on its physical location and size to be in a "ready" state should use this command, such as clicking, sending keys, locating child elements, and so on.

  #### Returns Promise<void>

  A Promise that's resolved when all conditions are met.

  Inherited from OjNavigationListBase.whenReady

Generated using TypeDoc